declare type QueryParams = {
    select?: string;
    join?: string;
    where?: string;
};
interface SQLiteItem {
    [key: string]: number | string;
    id: number;
}
export default abstract class SQLiteMobxModel<T extends object> {
    lastParams?: QueryParams;
    abstract table: string;
    abstract data: (T & SQLiteItem)[];
    loadItems(params?: QueryParams): Promise<void>;
    setItems(items: T[]): Promise<void>;
    addItems(items: T[]): Promise<void>;
    addItem(item: T): Promise<void>;
    setItem(item: T & SQLiteItem): Promise<void>;
    getItem(id: number): Promise<void>;
    editItem(item: T): Promise<void>;
    removeItem(item: T & SQLiteItem): Promise<void>;
    clear(): void;
    truncate(): Promise<void>;
}
export {};
//# sourceMappingURL=SQLiteMobxModel.d.ts.map